#ifndef __WINCOMPAT_H__
#define __WINCOMPAT_H__

// This file is supposed to be included at the beginning of all source files
// Should be used with the /FI (Forced Include File) compiler option.

#ifdef UNDER_CE

#include <altcecrt.h>

#include "abort.h"
#include "io.h"
#include "strerror.h"
#include "sys/types.h"

#define STD_INPUT_HANDLE (-10)
#define ENABLE_ECHO_INPUT (0x0004)

#else
	#include <string.h>
#endif

#include "libssh/libssh.h"

#ifdef strerror
#undef strerror
#endif

#define strerror(x) ssh_strerror(x)

#ifdef __cplusplus
extern C {
#endif

#ifdef UNDER_CE

// errno should not be used on Windows CE, only provided to make it build.
extern int errno;

// Use _strdup from coredll
_CRTIMP extern char *  __cdecl _strdup(const char * _Src);
#define strdup _strdup

// not present in time.h on Windows CE
struct tm *localtime(const time_t *time);
//struct tm *localtime_r(const time_t *time, struct tm *result);
size_t strftime(char *str, size_t count, const char *format, const struct tm *time );


typedef struct _WSAPROTOCOL_INFOA FAR * LPWSAPROTOCOL_INFOA;
typedef struct sockaddr FAR *LPSOCKADDR;
int WSAStringToAddressA(LPSTR               AddressString,
                        INT                 AddressFamily,
                        LPWSAPROTOCOL_INFOA lpProtocolInfo,
                        LPSOCKADDR          lpAddress,
                        LPINT               lpAddressLength
                        );

BOOL SHGetSpecialFolderPathA(HWND hwnd, LPSTR pszPath, int csidl, BOOL fCreate);

BOOL GetUserNameA(char* lpBuffer, LPDWORD lpnSize);
HANDLE GetStdHandle(DWORD nStdHandle);
BOOL GetConsoleMode(HANDLE  hConsoleHandle, LPDWORD lpMode);
BOOL SetConsoleMode(HANDLE hConsoleHandle, DWORD  dwMode);

#endif // UNDER_CE

LIBSSH_API const char* ssh_strerror(int err);

#ifdef __cplusplus
}
#endif

#endif
